<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/polymer/lib/elements/dom-if.html">
<link rel="import" href="../bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="../bower_components/iron-icon/iron-icon.html">
<link rel="import" href="../bower_components/vaadin-icons/vaadin-icons.html">
<link rel="import" href="../bower_components/vaadin-form-layout/vaadin-form-layout.html">
<link rel="import" href="../bower_components/vaadin-form-layout/vaadin-form-item.html">
<link rel="import" href="../bower_components/vaadin-text-field/vaadin-text-field.html">
<link rel="import" href="../bower_components/vaadin-text-field/vaadin-text-area.html">
<!--link rel="import" href="../bower_components/paper-spinner/paper-spinner-lite.html"-->
<link rel="import" href="../bower_components/vaadin-button/vaadin-button.html">
<link rel="import" href="../bower_components/vaadin-dialog/vaadin-dialog.html">
<link rel="import" href="../bower_components/vaadin-combo-box/vaadin-combo-box.html">
<link rel="import" href="../bower_components/brum-global-variable/brum-global-variable.html">
<link rel="import" href="auth-dialog.html">
<link rel="import" href="shared-styles.html">

<dom-module id="settings-page">
  <template>
    <style include="shared-styles">
      :host {
        display: block;
        background: transparent;
      }
      vaadin-grid-filter {
        width: 100%;
      }
      vaadin-text-field {
        width: 100%;
      }
    </style>

    <div class="card">
      <vaadin-vertical-layout>
        <h2>Settings</h2>
        <div>
          <iron-form id="form">
            <form>
              <vaadin-vertical-layout>
                <h3>General</h3>
                <vaadin-form-layout>
                  <vaadin-form-item>
                    <label slot="label">Backend URL</label>
                    <vaadin-text-field required placeholder="https://backend.example.com"
                                       class="full-width" value="{{backendBase}}"></vaadin-text-field>
                    <brum-global-variable key="backendBase" value="{{backendBase}}"></brum-global-variable>
                    <iron-ajax auto with-credentials url="[[backendBase]]/api/ping" loading="{{pingLoading}}"
                               last-error="{{pingError}}" last-response="{{pingResponse}}"></iron-ajax>
                    <template is="dom-if" if="[[pingLoading]]">
                      <iron-icon icon="vaadin:ellipsis-circle-o"></iron-icon>
                    </template>
                    <template is="dom-if" if="[[!pingLoading]]">
                      <template is="dom-if" if="[[pingResponse]]">
                        <iron-icon icon="vaadin:check-circle-o"></iron-icon>
                        <span>[[pingResponse.type]]</span>
                      </template>
                      <template is="dom-if" if="[[pingError]]">
                        <iron-icon icon="vaadin:close-circle-o"></iron-icon>
                      </template>
                    </template>
                    <!--paper-spinner-lite alt="..." active="[[pingLoading]]"></paper-spinner-lite-->
                  </vaadin-form-item>
                  <vaadin-form-item>
                    <label slot="label">API URL</label>
                    <vaadin-text-field class="full-width" value="[[apiBase]]" readonly></vaadin-text-field>
                    <brum-global-variable key="apiBase" value="{{apiBase}}" readonly></brum-global-variable>
                  </vaadin-form-item>
                  <vaadin-form-item>
                    <label slot="label">User authentication</label>
                    <brum-global-variable key="userAuth" value="{{userAuth}}" readonly></brum-global-variable>
                    <vaadin-button disabled="[[userAuth]]" on-click="openUserAuthDialog">Log in</vaadin-button>
                    <vaadin-button disabled="[[!userAuth]]" on-click="deAuthUser">Log out</vaadin-button>
                  </vaadin-form-item>
                  <vaadin-form-item>
                    <label slot="label">Team authentication</label>
                    <brum-global-variable key="teamAuth" value="{{teamAuth}}" readonly></brum-global-variable>
                    <vaadin-button disabled="[[teamAuth]]" on-click="openTeamAuthDialog">Log in</vaadin-button>
                    <vaadin-button disabled="[[!teamAuth]]" on-click="deAuthTeam">Log out</vaadin-button>
                  </vaadin-form-item>
                </vaadin-form-layout>
              </vaadin-vertical-layout>
            </form>
          </iron-form>
        </div>
      </vaadin-vertical-layout>
    </div>

    <auth-dialog id="authUserDialog" kind="user"></auth-dialog>
    <auth-dialog id="authTeamDialog" kind="team"></auth-dialog>
  </template>
  <script>
    class SettingsPage extends Polymer.Element {
      static get is() {
        return 'settings-page';
      }

      // noinspection JSUnusedGlobalSymbols
      openUserAuthDialog() {
        this.$.authUserDialog.opened = true;
      }

      // noinspection JSUnusedGlobalSymbols
      openTeamAuthDialog() {
        this.$.authTeamDialog.opened = true;
      }

      // noinspection JSUnusedGlobalSymbols
      deAuthUser() {
        return this.deAuth('user');
      }

      // noinspection JSUnusedGlobalSymbols
      deAuthTeam() {
        return this.deAuth('team');
      }

      deAuth(kind) {
        fetch(window.brumGlobalVariable.backendBase.value + '/' + kind + '/logout', {
          method: 'POST',
          credentials: 'include',
          cache: 'no-cache'
        }).catch(x => x).then(() => {
          const backendVariable = document.createElement('brum-global-variable');
          backendVariable.setAttribute('key', 'backendBase');
          document.body.appendChild(backendVariable);
          const oldBackend = backendVariable.value;
          backendVariable.value = '://'; // impossible url...
          backendVariable.value = oldBackend;
          document.body.removeChild(backendVariable);
        });
      }
    }

    window.customElements.define(SettingsPage.is, SettingsPage);
  </script>
</dom-module>
